<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 530/Test</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">

    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css"
        integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/brands.min.css"
        integrity="sha512-9YHSK59/rjvhtDcY/b+4rdnl0V4LPDWdkKceBl8ZLF5TB6745ml1AfluEU6dFWqwDw9lPvnauxFgpKvJqp7jiQ=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/fontawesome.min.css"
        integrity="sha512-SgaqKKxJDQ/tAUAAXzvxZz33rmn7leYDYfBP+YoMRSENhf3zJyx3SBASt/OfeQwBHA1nxMis7mM3EV/oYT6Fdw=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />

</head>
<style>
    #finding-place {
        display: flex;
        flex-direction: row;
        padding: 20px;
    }

    .selected-area {
        position: absolute;
        width: 70%;
        height: 34px;
        border: none;
    }

    .selected-area i {
        position: absolute;
        z-index: 2;
    }

    .wrap-flex {
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;
    }

    .i-1 {
        position: absolute;
        z-index: 2;
        left: 378px;
        top: 8px;
    }

    .i-2 {
        position: absolute;
        z-index: 2;
        left: 433px;
        top: 8px;
    }
</style>

<body>
    <div class="container">
        <h2 class="text-center">Danh sách sản phẩm </h2>
        <div class="jumbotron" id="finding-place">
            <div class="col-5 wrap-flex">
                <label>Quốc gia</label>
                <div>
                    <i class="fa-solid fa-caret-down i-1" style="color: #c2cdd8;"></i>
                    <select placeholder="--Chọn quốc gia--" class="selected-area" id="select-country">
                        <option value="0">--Chọn quốc gia--</option>

                    </select>
                </div>
            </div>
            <div class="col-5 wrap-flex">
                <label class="">Nhóm sản phẩm</label>
                <div>
                    <i class="fa-solid fa-caret-down i-2" style="color: #c2cdd8;"></i>
                    <select placeholder="--Chọn nhóm sản phẩm--" class="selected-area" id="select-category">
                        <option value="0">--Chọn nhóm sản phẩm--</option>

                    </select>
                </div>
            </div>
            <div class="col-2">
                <input type="submit" value="Lọc sản phẩm" class="btn btn-success">
            </div>
        </div>
        <button id="add-button" class="btn btn-success"><i class="fa-solid fa-plus"></i>Thêm mới</button>
        <table id="product-table" class="table table-bordered table-striped table-hover bg-info">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã sản phẩm</th>
                    <th>Tên sản phẩm</th>
                    <th>Nhóm sản phẩm</th>
                    <th>Quốc gia</th>
                    <th>Ảnh đại diện</th>
                    <th>Giá bán</th>
                    <th>Giá giảm</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <div id="edit-product-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Chỉnh sửa Product</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="edit-id-product-product">Mã sản phẩm</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-id-product-product" name="user"
                                    class="form-control inp-form">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="edit-product-name">Tên sản phẩm</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-product-name" name="user" class="form-control inp-form">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="edit-category-type-product">Nhóm sản phẩm</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="edit-category-type-product" name="user" class="form-control inp-form">
                                    <option value="0">None</option>

                                </select>

                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="edit-country-product">Quốc Gia</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="edit-country-product" name="user" class="form-control inp-form">
                                    <option value="0">None</option>

                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-customer-type-user">Ảnh Đại Diện</label>
                            </div>
                            <div class="col-sm-8" id="avatar-edit-product">
                                <img class="img-thumbnail" src="">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="edit-original-price">Giá gốc</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-original-price" name="user" class="form-control inp-form">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="edit-discount-price">Giá giảm</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-discount-price" name="user" class="form-control inp-form">
                            </div>
                        </div>

                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-edit-user" data-dismiss="modal">Confirm</button>
                    <button class="btn btn-success" id="btn-cancel">Hủy Bỏ</button>
                </div>
            </div>
        </div>
    </div>

</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1/";
    const vAPI_URL = gBASE_URL + "/products/";
    var gCOUNTRIES_LIST = [];
    var gCATEGORY_TYPE_LIST = [];
    const gPRODUCT_COL = ["id", "productCode", "productName", "categoryId", "countryId", "imagUrl", "price", "discountPrice"];
    const gPRODUCT_ID_COL = 0;
    const gPRODUCT_CODE_COL = 1;
    const gPRODUCT_NAME_COL = 2;
    const gPRODUCT_CATEGORY_ID_COL = 3;
    const gPRODUCT_COUNTRY_ID_COL = 4;
    const gPRODUCT_IMAGE_COL = 5;
    const gPRODUCT_PRICE_COL = 6;
    const gPRODUCT_DISCOUNT_PRICE_COL = 7;
    const gPRODUCT_ACTION_COL = 8;

    var gDataProDuctTable = $("#product-table").DataTable({
        columns: [
            { data: gPRODUCT_COL[gPRODUCT_ID_COL] },
            { data: gPRODUCT_COL[gPRODUCT_CODE_COL] },
            { data: gPRODUCT_COL[gPRODUCT_NAME_COL] },
            {
                data: gPRODUCT_COL[gPRODUCT_CATEGORY_ID_COL],
                render: function (data, type, row) {
                    console.log(gCATEGORY_TYPE_LIST);
                    for (var bI = 0; bI < gCATEGORY_TYPE_LIST.length; bI++) {
                        if (type == "display") {
                            var bIdCategoryFromCTApi = gCATEGORY_TYPE_LIST[bI].id;
                            var bNameCategoryFromCTApi = gCATEGORY_TYPE_LIST[bI].categoryName;
                            if (data == bIdCategoryFromCTApi) {
                                return `<p>${bNameCategoryFromCTApi}</p>`
                            }
                        }
                    }
                }
            },
            {
                data: gPRODUCT_COL[gPRODUCT_COUNTRY_ID_COL],
                render: function (data, type, row) {
                    for (var bI = 0; bI < gCOUNTRIES_LIST.length; bI++) {
                        if (type == "display") {
                            var bIdCountryFromProduct = row.countryId;
                            var bNameCountryFromCountriesAPI = gCOUNTRIES_LIST[bI].countryName;
                            var bIdCountryFromCountriesAPI = gCOUNTRIES_LIST[bI].id;
                            if (data == bIdCountryFromCountriesAPI) {
                                return `<p>${bNameCountryFromCountriesAPI}</p>`
                            }
                        }

                    }
                }
            },
            {
                data: gPRODUCT_COL[gPRODUCT_IMAGE_COL],
                render: function (data) {
                    return `<img src="${data}" class="img-thumbnail">`
                }
            },
            {
                data: gPRODUCT_COL[gPRODUCT_PRICE_COL],
                render: function (data, type) {
                    if (type == "display") {
                        return `<p>$ ${data}</p>`
                    }
                }
            },
            {
                data: gPRODUCT_COL[gPRODUCT_DISCOUNT_PRICE_COL],
                render: function (data, type) {
                    if (type == "display") {
                        return `<p>$ ${data}</p>`
                    }
                }
            },
            { data: gPRODUCT_COL[gPRODUCT_ACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gPRODUCT_ACTION_COL,
                defaultContent: `
                <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">`
            },
        ]
        ,
    })

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();

    })
    $("#product-table").on("click", ".edit-user", function () {
        onEditIconCLick(this);
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        getAllProduct()
        getAllCountriesToSelect();
        getAllCategoryTypeToSelect();
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    function onEditIconCLick(paramEdit) {
        var vId = getInformationFromId(paramEdit);
        $("#edit-product-modal").modal("show");
        callApiToGetSpecificallyProductById(vId);
    }

    function callApiToGetSpecificallyProductById(paramId) {
        $.ajax({
            url: vAPI_URL + "/" + paramId,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                pushProductToEditModal(paramRes);
            },
            error: function (paramError) {
                console.log(paramError.responseText);
            }
        })
    }

    function pushProductToEditModal(paramObjProduct) {
        $("#edit-id-product-product").val(paramObjProduct.productCode);
        $("#edit-product-name").val(paramObjProduct.productName);
        $("#edit-category-type-product ").val(paramObjProduct.categoryId);
        $("#edit-country-product").val(paramObjProduct.countryId);
        $("#avatar-edit-product").html(`<img class="img-thumbnail" src="${paramObjProduct.imagUrl}">`);
        $("#edit-original-price").val(paramObjProduct.price);
        $("#edit-discount-price").val(paramObjProduct.discountPrice);

    }

    function getInformationFromId(paramProduct) {
        var vTableRow = $(paramProduct).parents("tr");
        var vRowData = gDataProDuctTable.row(vTableRow).data();
        return vRowData.id;
    }

    function getAllCategoryTypeToSelect() {
        $.ajax({
            url: gBASE_URL + "/categories/",
            type: "GET",
            success: function (paramRes) {
                gCATEGORY_TYPE_LIST = paramRes;
                console.log(gCATEGORY_TYPE_LIST);
                loadCategoryToSelectCategory(paramRes);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }

        });
    }

    function loadCategoryToSelectCategory(paramCategories) {
        var vSelectCategory = $("#select-category");
        var vEditCategory = $("#edit-category-type-product");
        for (var bI in paramCategories) {
            $("<option>", {
                html: paramCategories[bI].categoryName,
                value: paramCategories[bI].id
            }).appendTo(vSelectCategory)
        }
        for (var bI2 in paramCategories) {
            $("<option>", {
                html: paramCategories[bI2].categoryName,
                value: paramCategories[bI2].id
            }).appendTo(vEditCategory)
        }

    }

    function getAllCountriesToSelect() {
        $.ajax({
            url: gBASE_URL + "/countries/",
            type: "GET",
            success: function (paramRes) {
                gCOUNTRIES_LIST = paramRes;
                console.log(gCOUNTRIES_LIST);
                loadCountryToSelectCountries(paramRes);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        })
    }

    function loadCountryToSelectCountries(paramArraCountries) {
        var vCountriesSelect = $("#select-country");
        var vCountriesEdit = $("#edit-country-product");
        for (var bI = 0; bI < paramArraCountries.length; bI++) {
            $("<option>", {
                html: paramArraCountries[bI].countryName,
                value: paramArraCountries[bI].id
            }).appendTo(vCountriesSelect)
        }
        for (var bI2 = 0; bI2 < paramArraCountries.length; bI2++) {
            $("<option>", {
                html: paramArraCountries[bI2].countryName,
                value: paramArraCountries[bI2].id
            }).appendTo(vCountriesEdit)
        }

    }

    function getAllProduct() {
        $.ajax({
            url: gBASE_URL + "/products/",
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                loadProductToTable(paramRes);
            },
            error: function (paramError) {
                console.log(paramError.responseText);
            }
        })

    }

    function loadProductToTable(paramProduct) {
        gDataProDuctTable.clear();
        gDataProDuctTable.rows.add(paramProduct);
        gDataProDuctTable.draw();
    }
</script>

</html>